;;;; This file is part of XMLTools
;;;; Copyright (C) 2004 Sergey Poznyakoff
;;;;
;;;; XMLTools is free software; you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation; either version 2 of the License, or
;;;; (at your option) any later version.
;;;;
;;;; XMLTools is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;;
;;;; You should have received a copy of the GNU General Public License
;;;; along with XMLTools; if not, write to the Free Software
;;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
;;;;
(define-module (xmltools dict))

(define-public (dict:encode-string str)
  (apply
   string-append
   (map
    (lambda (x)
      (let ((n (char->integer x)))
	(if (or (and (> n 97) (< n 122))
		(and (> n 65) (< n 90))
		(and (> n 48) (< n 57)))
	   (string x)
	   (let ((s (number->string n 16)))
	     (string-append "%"
			    (if (< n 16)
				"0" "")
			    s)))))
    (string->list str))))

(define-public (dict:decode-string str)
  (do ((i 0)
       (sl '()))
      ((= i (string-length str)) (list->string (reverse sl)))
    (let ((c (string-ref str i)))
      (set! sl
	    (cons
	     (cond
	      ((char=? c #\%)
	       (set! i (+ i 3))
	       (integer->char
		(string->number (substring str (- i 2) i) 16)))
	      (else
	       (set! i (1+ i))
	       c))
	     sl)))))
